# CfnFileSystem

The `AWS::FSx::FileSystem` resource is an Amazon FSx resource type that specifies an Amazon FSx file system.

You can create any of the following supported file system types:

- Amazon FSx for Lustre
- Amazon FSx for NetApp ONTAP
- FSx for OpenZFS
- Amazon FSx for Windows File Server

Extends: Construct › CfnElement › CfnRefElement › CfnResource › CfnFileSystem
Implements: IInspectable, ITaggable, IEnvironmentAware, IFileSystemRef, IConstruct, IDependable

- CloudFormation: [`AWS::FSx::FileSystem`](https://docs.aws.amazon.com/AWSCloudFormation/latest/TemplateReference/aws-resource-fsx-filesystem.html)
- Source: Generated code
- Type last changed: v2.252.0 · 30 Apr 2026

## Example

```ts
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_fsx as fsx } from 'aws-cdk-lib';
const cfnFileSystem = new fsx.CfnFileSystem(this, 'MyCfnFileSystem', {
  fileSystemType: 'fileSystemType',
  subnetIds: ['subnetIds'],

  // the properties below are optional
  backupId: 'backupId',
  fileSystemTypeVersion: 'fileSystemTypeVersion',
  kmsKeyId: 'kmsKeyId',
  lustreConfiguration: {
    autoImportPolicy: 'autoImportPolicy',
    automaticBackupRetentionDays: 123,
    copyTagsToBackups: false,
    dailyAutomaticBackupStartTime: 'dailyAutomaticBackupStartTime',
    dataCompressionType: 'dataCompressionType',
    dataReadCacheConfiguration: {
      sizeGiB: 123,
      sizingMode: 'sizingMode',
    },
    deploymentType: 'deploymentType',
    driveCacheType: 'driveCacheType',
    efaEnabled: false,
    exportPath: 'exportPath',
    importedFileChunkSize: 123,
    importPath: 'importPath',
    logConfiguration: {
      level: 'level',

      // the properties below are optional
      destination: 'destination',
    },
    metadataConfiguration: {
      iops: 123,
      mode: 'mode',
    },
    perUnitStorageThroughput: 123,
    throughputCapacity: 123,
    weeklyMaintenanceStartTime: 'weeklyMaintenanceStartTime',
  },
  networkType: 'networkType',
  ontapConfiguration: {
    deploymentType: 'deploymentType',

    // the properties below are optional
    automaticBackupRetentionDays: 123,
    dailyAutomaticBackupStartTime: 'dailyAutomaticBackupStartTime',
    diskIopsConfiguration: {
      iops: 123,
      mode: 'mode',
    },
    endpointIpAddressRange: 'endpointIpAddressRange',
    endpointIpv6AddressRange: 'endpointIpv6AddressRange',
    fsxAdminPassword: 'fsxAdminPassword',
    haPairs: 123,
    preferredSubnetId: 'preferredSubnetId',
    routeTableIds: ['routeTableIds'],
    throughputCapacity: 123,
    throughputCapacityPerHaPair: 123,
    weeklyMaintenanceStartTime: 'weeklyMaintenanceStartTime',
  },
  openZfsConfiguration: {
    deploymentType: 'deploymentType',

    // the properties below are optional
    automaticBackupRetentionDays: 123,
    copyTagsToBackups: false,
    copyTagsToVolumes: false,
    dailyAutomaticBackupStartTime: 'dailyAutomaticBackupStartTime',
    diskIopsConfiguration: {
      iops: 123,
      mode: 'mode',
    },
    endpointIpAddressRange: 'endpointIpAddressRange',
    endpointIpv6AddressRange: 'endpointIpv6AddressRange',
    options: ['options'],
    preferredSubnetId: 'preferredSubnetId',
    readCacheConfiguration: {
      sizeGiB: 123,
      sizingMode: 'sizingMode',
    },
    rootVolumeConfiguration: {
      copyTagsToSnapshots: false,
      dataCompressionType: 'dataCompressionType',
      nfsExports: [{
        clientConfigurations: [{
          clients: 'clients',
          options: ['options'],
        }],
      }],
      readOnly: false,
      recordSizeKiB: 123,
      userAndGroupQuotas: [{
        id: 123,
        storageCapacityQuotaGiB: 123,
        type: 'type',
      }],
    },
    routeTableIds: ['routeTableIds'],
    throughputCapacity: 123,
    weeklyMaintenanceStartTime: 'weeklyMaintenanceStartTime',
  },
  securityGroupIds: ['securityGroupIds'],
  storageCapacity: 123,
  storageType: 'storageType',
  tags: [{
    key: 'key',
    value: 'value',
  }],
  windowsConfiguration: {
    throughputCapacity: 123,

    // the properties below are optional
    activeDirectoryId: 'activeDirectoryId',
    aliases: ['aliases'],
    auditLogConfiguration: {
      fileAccessAuditLogLevel: 'fileAccessAuditLogLevel',
      fileShareAccessAuditLogLevel: 'fileShareAccessAuditLogLevel',

      // the properties below are optional
      auditLogDestination: 'auditLogDestination',
    },
    automaticBackupRetentionDays: 123,
    copyTagsToBackups: false,
    dailyAutomaticBackupStartTime: 'dailyAutomaticBackupStartTime',
    deploymentType: 'deploymentType',
    diskIopsConfiguration: {
      iops: 123,
      mode: 'mode',
    },
    fsrmConfiguration: {
      fsrmServiceEnabled: false,

      // the properties below are optional
      eventLogDestination: 'eventLogDestination',
    },
    preferredSubnetId: 'preferredSubnetId',
    selfManagedActiveDirectoryConfiguration: {
      dnsIps: ['dnsIps'],
      domainJoinServiceAccountSecret: 'domainJoinServiceAccountSecret',
      domainName: 'domainName',
      fileSystemAdministratorsGroup: 'fileSystemAdministratorsGroup',
      organizationalUnitDistinguishedName: 'organizationalUnitDistinguishedName',
      password: 'password',
      userName: 'userName',
    },
    weeklyMaintenanceStartTime: 'weeklyMaintenanceStartTime',
  },
});
```

## Initializer

```ts
new CfnFileSystem(scope: Construct, id: string, props: CfnFileSystemProps)
```

## Construct Props

- `backupId`: string — The ID of the file system backup that you are using to create a file system.

  For more information, see [CreateFileSystemFromBackup](https://docs.aws.amazon.com/fsx/latest/APIReference/API_CreateFileSystemFromBackup.html) .

- `fileSystemType`: string (required) — The type of Amazon FSx file system, which can be `LUSTRE` , `WINDOWS` , `ONTAP` , or `OPENZFS` .

- `fileSystemTypeVersion`: string — For FSx for Lustre file systems, sets the Lustre version for the file system that you're creating.

  Valid values are `2.10` , `2.12` , and `2.15` :

  - `2.10` is supported by the Scratch and Persistent_1 Lustre deployment types.
  - `2.12` is supported by all Lustre deployment types, except for `PERSISTENT_2` with a metadata configuration mode.
  - `2.15` is supported by all Lustre deployment types and is recommended for all new file systems.

  Default value is `2.10` , except for the following deployments:

  - Default value is `2.12` when `DeploymentType` is set to `PERSISTENT_2` without a metadata configuration mode.
  - Default value is `2.15` when `DeploymentType` is set to `PERSISTENT_2` with a metadata configuration mode.

- `kmsKeyId`: string — The ID of the AWS Key Management Service ( AWS ) key used to encrypt Amazon FSx file system data.

  Used as follows with Amazon FSx file system types:

  - Amazon FSx for Lustre `PERSISTENT_1` and `PERSISTENT_2` deployment types only.

  `SCRATCH_1` and `SCRATCH_2` types are encrypted using the Amazon FSx service AWS  key for your account.
  - Amazon FSx for NetApp ONTAP
  - Amazon FSx for OpenZFS
  - Amazon FSx for Windows File Server

  If this ID isn't specified, the Amazon FSx-managed key for your account is used. For more information, see [Encrypt](https://docs.aws.amazon.com//kms/latest/APIReference/API_Encrypt.html) in the *AWS Key Management Service API Reference* .

- `lustreConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFileSystem.LustreConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_fsx.CfnFileSystem.LustreConfigurationProperty.html) — The Lustre configuration for the file system being created.

  This configuration is required if the `FileSystemType` is set to `LUSTRE` .

  > The following parameters are not supported when creating Lustre file systems with a data repository association.
  >
  > - `AutoImportPolicy`
  > - `ExportPath`
  > - `ImportedChunkSize`
  > - `ImportPath`

- `networkType`: string — The network type of the file system.

- `ontapConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFileSystem.OntapConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_fsx.CfnFileSystem.OntapConfigurationProperty.html) — The ONTAP configuration properties of the FSx for ONTAP file system that you are creating.

  This configuration is required if the `FileSystemType` is set to `ONTAP` .

- `openZfsConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFileSystem.OpenZFSConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_fsx.CfnFileSystem.OpenZFSConfigurationProperty.html) — The Amazon FSx for OpenZFS configuration properties for the file system that you are creating.

  This configuration is required if the `FileSystemType` is set to `OPENZFS` .

- `securityGroupIds`: string[] — A list of IDs specifying the security groups to apply to all network interfaces created for file system access.

  This list isn't returned in later requests to describe the file system.

  > You must specify a security group if you are creating a Multi-AZ FSx for ONTAP file system in a VPC subnet that has been shared with you.

- `storageCapacity`: number — Sets the storage capacity of the file system that you're creating.

  `StorageCapacity` is required if you are creating a new file system. It is not required if you are creating a file system by restoring a backup.

  *FSx for Lustre file systems* - The amount of storage capacity that you can configure depends on the value that you set for `StorageType` and the Lustre `DeploymentType` , as follows:

  - For `SCRATCH_2` , `PERSISTENT_2` and `PERSISTENT_1` deployment types using SSD storage type, the valid values are 1200 GiB, 2400 GiB, and increments of 2400 GiB.
  - For `PERSISTENT_1` HDD file systems, valid values are increments of 6000 GiB for 12 MB/s/TiB file systems and increments of 1800 GiB for 40 MB/s/TiB file systems.
  - For `SCRATCH_1` deployment type, valid values are 1200 GiB, 2400 GiB, and increments of 3600 GiB.

  *FSx for ONTAP file systems* - The amount of SSD storage capacity that you can configure depends on the value of the `HAPairs` property. The minimum value is calculated as 1,024 GiB * HAPairs and the maximum is calculated as 524,288 GiB * HAPairs, up to a maximum amount of SSD storage capacity of 1,048,576 GiB (1 pebibyte).

  *FSx for OpenZFS file systems* - The amount of storage capacity that you can configure is from 64 GiB up to 524,288 GiB (512 TiB). If you are creating a file system from a backup, you can specify a storage capacity equal to or greater than the original file system's storage capacity.

  *FSx for Windows File Server file systems* - The amount of storage capacity that you can configure depends on the value that you set for `StorageType` as follows:

  - For SSD storage, valid values are 32 GiB-65,536 GiB (64 TiB).
  - For HDD storage, valid values are 2000 GiB-65,536 GiB (64 TiB).

- `storageType`: string — Sets the storage class for the file system that you're creating.

  Valid values are `SSD` , `HDD` , and `INTELLIGENT_TIERING` .

  - Set to `SSD` to use solid state drive storage. SSD is supported on all Windows, Lustre, ONTAP, and OpenZFS deployment types.
  - Set to `HDD` to use hard disk drive storage, which is supported on `SINGLE_AZ_2` and `MULTI_AZ_1` Windows file system deployment types, and on `PERSISTENT_1` Lustre file system deployment types.
  - Set to `INTELLIGENT_TIERING` to use fully elastic, intelligently-tiered storage. Intelligent-Tiering is only available for OpenZFS file systems with the Multi-AZ deployment type and for Lustre file systems with the Persistent_2 deployment type.

  Default value is `SSD` . For more information, see [Storage type options](https://docs.aws.amazon.com/fsx/latest/WindowsGuide/optimize-fsx-costs.html#storage-type-options) in the *FSx for Windows File Server User Guide* , [FSx for Lustre storage classes](https://docs.aws.amazon.com/fsx/latest/LustreGuide/using-fsx-lustre.html#lustre-storage-classes) in the *FSx for Lustre User Guide* , and [Working with Intelligent-Tiering](https://docs.aws.amazon.com/fsx/latest/OpenZFSGuide/performance-intelligent-tiering) in the *Amazon FSx for OpenZFS User Guide* .

- `subnetIds`: string[] (required) — Specifies the IDs of the subnets that the file system will be accessible from.

  For Windows and ONTAP `MULTI_AZ_1` deployment types,provide exactly two subnet IDs, one for the preferred file server and one for the standby file server. You specify one of these subnets as the preferred subnet using the `WindowsConfiguration > PreferredSubnetID` or `OntapConfiguration > PreferredSubnetID` properties. For more information about Multi-AZ file system configuration, see [Availability and durability: Single-AZ and Multi-AZ file systems](https://docs.aws.amazon.com/fsx/latest/WindowsGuide/high-availability-multiAZ.html) in the *Amazon FSx for Windows User Guide* and [Availability and durability](https://docs.aws.amazon.com/fsx/latest/ONTAPGuide/high-availability-multiAZ.html) in the *Amazon FSx for ONTAP User Guide* .

  For Windows `SINGLE_AZ_1` and `SINGLE_AZ_2` and all Lustre deployment types, provide exactly one subnet ID. The file server is launched in that subnet's Availability Zone.

- `tags`: [CfnTag](/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — The tags to associate with the file system.

  For more information, see [Tagging your Amazon FSx resources](https://docs.aws.amazon.com/fsx/latest/LustreGuide/tag-resources.html) in the *Amazon FSx for Lustre User Guide* .

- `windowsConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFileSystem.WindowsConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_fsx.CfnFileSystem.WindowsConfigurationProperty.html) — The configuration object for the Microsoft Windows file system you are creating.

  This configuration is required if `FileSystemType` is set to `WINDOWS` .

## Properties

- `attrDnsName`: string — Returns the FSx for Windows file system's DNSName.

  Example: `amznfsxp1honlek.corp.example.com`

- `attrId`: string

- `attrLustreMountName`: string — Returns the Lustre file system's `LustreMountName` .

  Example for `SCRATCH_1` deployment types: This value is always `fsx` .

  Example for `SCRATCH_2` and `PERSISTENT` deployment types: `2p3fhbmv`

- `attrResourceArn`: string — Returns the Amazon Resource Name (ARN) for the Amazon FSx file system.

  Example: `arn:aws:fsx:us-east-2:111122223333:file-system/fs-0123abcd56789ef0a`

- `attrRootVolumeId`: string — Returns the root volume ID of the FSx for OpenZFS file system.

  Example: `fsvol-0123456789abcdefa`

- `backupId`: string — The ID of the file system backup that you are using to create a file system.

- `CFN_RESOURCE_TYPE_NAME`: string (static) — The CloudFormation resource type name for this resource class.

- `cfnOptions`: [ICfnResourceOptions](/cdk/api/v2/docs/aws-cdk-lib.ICfnResourceOptions.html) — Options for this resource, such as condition, update policy etc.

- `cfnResourceType`: string — AWS resource type.

- `creationStack`: string[]

- `env`: [ResourceEnvironment](/cdk/api/v2/docs/aws-cdk-lib.interfaces.ResourceEnvironment.html)

- `fileSystemRef`: [FileSystemReference](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_fsx.FileSystemReference.html) — A reference to a FileSystem resource.

- `fileSystemType`: string — The type of Amazon FSx file system, which can be `LUSTRE` , `WINDOWS` , `ONTAP` , or `OPENZFS` .

- `fileSystemTypeVersion`: string — For FSx for Lustre file systems, sets the Lustre version for the file system that you're creating.

- `kmsKeyId`: string — The ID of the AWS Key Management Service ( AWS ) key used to encrypt Amazon FSx file system data.

- `logicalId`: string — The logical ID for this CloudFormation stack element.

  The logical ID of the element
  is calculated from the path of the resource node in the construct tree.

  To override this value, use `overrideLogicalId(newLogicalId)`.

- `lustreConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFileSystem.LustreConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_fsx.CfnFileSystem.LustreConfigurationProperty.html) — The Lustre configuration for the file system being created.

- `networkType`: string — The network type of the file system.

- `node`: [Node](/cdk/api/v2/docs/constructs.Node.html) — The tree node.

- `ontapConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFileSystem.OntapConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_fsx.CfnFileSystem.OntapConfigurationProperty.html) — The ONTAP configuration properties of the FSx for ONTAP file system that you are creating.

- `openZfsConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFileSystem.OpenZFSConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_fsx.CfnFileSystem.OpenZFSConfigurationProperty.html) — The Amazon FSx for OpenZFS configuration properties for the file system that you are creating.

- `ref`: string — Return a string that will be resolved to a CloudFormation `{ Ref }` for this element.

  If, by any chance, the intrinsic reference of a resource is not a string, you could
  coerce it to an IResolvable through `Lazy.any({ produce: resource.ref })`.

- `securityGroupIds`: string[] — A list of IDs specifying the security groups to apply to all network interfaces created for file system access.

- `stack`: [Stack](/cdk/api/v2/docs/aws-cdk-lib.Stack.html) — The stack in which this element is defined.

  CfnElements must be defined within a stack scope (directly or indirectly).

- `storageCapacity`: number — Sets the storage capacity of the file system that you're creating.

- `storageType`: string — Sets the storage class for the file system that you're creating.

- `subnetIds`: string[] — Specifies the IDs of the subnets that the file system will be accessible from.

- `tags`: [TagManager](/cdk/api/v2/docs/aws-cdk-lib.TagManager.html) — Tag Manager which manages the tags for this resource.

- `tagsRaw`: [CfnTag](/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — The tags to associate with the file system.

- `windowsConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnFileSystem.WindowsConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_fsx.CfnFileSystem.WindowsConfigurationProperty.html) — The configuration object for the Microsoft Windows file system you are creating.

## Methods

- `addDeletionOverride(path: string): void` — Syntactic sugar for `addOverride(path, undefined)`.

  **Parameters**

  - `path` — The path of the value to delete.

- `addDependency(target: CfnResource): void` — Use `addResourceDependency` instead.

  This method has been renamed to `addResourceDependency` to more clearly
  set it apart from `construct.node.addDependency`. See the documentation
  of that function for more details.

- `addDependsOn(target: CfnResource): void` — Use `addResourceDependency` instead.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method has been renamed to `addResourceDependency`, which makes it
  more clear that this method operates at a different level from the
  construct-level `construct.node.addDependency()` mechanism.

- `addMetadata(key: string, value: any): void` — Add a value to the CloudFormation Resource Metadata.

- `addOverride(path: string, value: any): void` — Adds an override to the synthesized CloudFormation resource.

  To add a
  property override, either use `addPropertyOverride` or prefix `path` with
  "Properties." (i.e. `Properties.TopicName`).

  If the override is nested, separate each nested level using a dot (.) in the path parameter.
  If there is an array as part of the nesting, specify the index in the path.

  To include a literal `.` in the property name, prefix with a `\`. In most
  programming languages you will need to write this as `"\\."` because the
  `\` itself will need to be escaped.

  For example,
  ```typescript
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
  ```
  would add the overrides
  ```json
  "Properties": {
    "GlobalSecondaryIndexes": [
      {
        "Projection": {
          "NonKeyAttributes": [ "myattribute" ]
          ...
        }
        ...
      },
      {
        "ProjectionType": "INCLUDE"
        ...
      },
    ]
    ...
  }
  ```

  The `value` argument to `addOverride` will not be processed or translated
  in any way. Pass raw JSON values in here with the correct capitalization
  for CloudFormation. If you pass CDK classes or structs, they will be
  rendered with lowercased key names, and CloudFormation will reject the
  template.

  **Parameters**

  - `path` — - The path of the property, you can use dot notation to override values in complex types.
  - `value` — - The value.

- `addPropertyDeletionOverride(propertyPath: string): void` — Adds an override that deletes the value of a property from the resource definition.

  **Parameters**

  - `propertyPath` — The path to the property.

- `addPropertyOverride(propertyPath: string, value: any): void` — Adds an override to a resource property.

  Syntactic sugar for `addOverride("Properties.<...>", value)`.

  **Parameters**

  - `propertyPath` — The path of the property.
  - `value` — The value.

- `addResourceDependency(target: CfnResource, reason?: string): void` — Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method only adds dependencies between L1 resources. If you are
  looking for a generic construct-to-construct dependency mechanism that works
  for all constructs including L2s, use `construct.node.addDependency` instead.

- `applyCrossStackReferenceStrength(strength: ReferenceStrength): void` — Sets the cross-stack reference strength for this resource.

  When set, any cross-stack reference to this resource will use the specified
  strength instead of the global default from the consuming stack's context.

  **Parameters**

  - `strength` — - The reference strength to use for this resource.

- `applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): void` — Sets the deletion policy of the resource based on the removal policy specified.

  The Removal Policy controls what happens to this resource when it stops
  being managed by CloudFormation, either because you've removed it from the
  CDK application or because you've made a change that requires the resource
  to be replaced.

  The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
  account for data recovery and cleanup later (`RemovalPolicy.RETAIN`). In some
  cases, a snapshot can be taken of the resource prior to deletion
  (`RemovalPolicy.SNAPSHOT`). A list of resources that support this policy
  can be found in the following link:

- `cfnPropertyName(cdkPropertyName: string): string`

- `getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Reference` — Returns a token for an runtime attribute of this resource.

  Ideally, use generated attribute accessors (e.g. `resource.arn`), but this can be used for future compatibility
  in case there is no generated attribute.

  **Parameters**

  - `attributeName` — The name of the attribute.

- `getMetadata(key: string): any` — Retrieve a value value from the CloudFormation Resource Metadata.

- `inspect(inspector: TreeInspector): void` — Examines the CloudFormation resource and discloses attributes.

  **Parameters**

  - `inspector` — tree inspector to collect and process attributes.

- `isCfnElement(x: any): boolean` (static) — Returns `true` if a construct is a stack element (i.e. part of the synthesized cloudformation template).

  Uses duck-typing instead of `instanceof` to allow stack elements from different
  versions of this library to be included in the same stack.

  **Returns:** The construct as a stack element or undefined if it is not a stack element.

- `isCfnFileSystem(x: any): boolean` (static) — Checks whether the given object is a CfnFileSystem.

- `isCfnResource(x: any): boolean` (static) — Check whether the given object is a CfnResource.

- `isConstruct(x: any): boolean` (static) — Checks if `x` is a construct.

  Use this method instead of `instanceof` to properly detect `Construct`
  instances, even when the construct library is symlinked.

  Explanation: in JavaScript, multiple copies of the `constructs` library on
  disk are seen as independent, completely different libraries. As a
  consequence, the class `Construct` in each copy of the `constructs` library
  is seen as a different class, and an instance of one class will not test as
  `instanceof` the other class. `npm install` will not create installations
  like this, but users may manually symlink construct libraries together or
  use a monorepo tool: in those cases, multiple copies of the `constructs`
  library can be accidentally installed, and `instanceof` will behave
  unpredictably. It is safest to avoid using `instanceof`, and using
  this type-testing method instead.

  **Parameters**

  - `x` — Any object.

  **Returns:** true if `x` is an object created from a class which extends `Construct`.

- `obtainDependencies(): Stack | CfnResource[]` — Retrieves an array of resources and stacks this resource depends on.

  For resources depended on directly, returns the `CfnResource` object. For
  dependencies on other stacks, returns the `Stack` object. The order of the
  array is not guaranteed.

- `overrideLogicalId(newLogicalId: string): void` — Overrides the auto-generated logical ID with a specific ID.

  **Parameters**

  - `newLogicalId` — The new logical ID to use for this stack element.

- `removeDependency(target: CfnResource): void` — Use `removeResourceDependency` instead

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `removeResourceDependency(target: CfnResource): void` — Indicates that this resource no longer depends on another resource.

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `replaceDependency(target: CfnResource, newTarget: CfnResource): void` — Replaces one dependency with another.

  **Parameters**

  - `target` — The dependency to replace.
  - `newTarget` — The new dependency to add.

- `toString(): string` — Returns a string representation of this construct.

  **Returns:** a string representation of this resource

- `with(...mixins: IMixin[]): IConstruct` — Applies one or more mixins to this construct.

  Mixins are applied in order. The list of constructs is captured at the
  start of the call, so constructs added by a mixin will not be visited.
  Use multiple `with()` calls if subsequent mixins should apply to added
  constructs.
